<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AirlineGraph.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">airline-graph</a> &gt; <a href="index.source.html" class="el_package">com.boxever.challenge.airline</a> &gt; <span class="el_source">AirlineGraph.java</span></div><h1>AirlineGraph.java</h1><pre class="source lang-java linenums">package com.boxever.challenge.airline;

import lombok.Getter;
import org.jgrapht.graph.DefaultWeightedEdge;
import org.jgrapht.graph.SimpleWeightedGraph;
import org.jgrapht.graph.builder.GraphTypeBuilder;
import org.springframework.stereotype.Component;

import java.util.Set;

@Getter
@Component
public class AirlineGraph {

<span class="fc" id="L15">    public static final Set&lt;String&gt; AIRPORTS = Set.of(&quot;DUB&quot;,</span>
            &quot;LHR&quot;,
            &quot;CDG&quot;,
            &quot;BOS&quot;,
            &quot;BKK&quot;,
            &quot;ORD&quot;,
            &quot;LAS&quot;,
            &quot;NYC&quot;,
            &quot;LAX&quot;,
            &quot;SYD&quot;);


<span class="fc" id="L27">    private SimpleWeightedGraph&lt;String, DefaultWeightedEdge&gt; graph;</span>

<span class="fc" id="L29">    public AirlineGraph() {</span>
<span class="fc" id="L30">        this.graph = buildEmptyAirlineGraph();</span>
<span class="fc" id="L31">        this.fillGraph(graph);</span>
<span class="fc" id="L32">    }</span>

    private SimpleWeightedGraph&lt;String, DefaultWeightedEdge&gt; buildEmptyAirlineGraph() {
<span class="fc" id="L35">        return (SimpleWeightedGraph)GraphTypeBuilder.&lt;String, DefaultWeightedEdge&gt;undirected()</span>
<span class="fc" id="L36">                .allowingMultipleEdges(false)</span>
<span class="fc" id="L37">                .allowingSelfLoops(false)</span>
<span class="fc" id="L38">                .edgeClass(DefaultWeightedEdge.class)</span>
<span class="fc" id="L39">                .weighted(true)</span>
<span class="fc" id="L40">                .buildGraph();</span>
    }

    private void fillGraph(SimpleWeightedGraph&lt;String, DefaultWeightedEdge&gt; graph) {
<span class="fc" id="L44">        this.addVertexs(graph);</span>
<span class="fc" id="L45">        this.addEdges(graph);</span>
<span class="fc" id="L46">    }</span>

    private void addVertexs(SimpleWeightedGraph&lt;String, DefaultWeightedEdge&gt; graph) {
<span class="fc" id="L49">        AIRPORTS.forEach(graph::addVertex);</span>
<span class="fc" id="L50">    }</span>

    private void addEdges(SimpleWeightedGraph&lt;String, DefaultWeightedEdge&gt; graph) {
<span class="fc" id="L53">        this.addEdge(graph, &quot;DUB&quot;, &quot;LHR&quot;, 1);</span>
<span class="fc" id="L54">        this.addEdge(graph, &quot;DUB&quot;, &quot;CDG&quot;, 2);</span>
<span class="fc" id="L55">        this.addEdge(graph, &quot;CDG&quot;, &quot;BOS&quot;, 6);</span>
<span class="fc" id="L56">        this.addEdge(graph, &quot;CDG&quot;, &quot;BKK&quot;, 9);</span>
<span class="fc" id="L57">        this.addEdge(graph, &quot;ORD&quot;, &quot;LAS&quot;, 2);</span>
<span class="fc" id="L58">        this.addEdge(graph, &quot;LHR&quot;, &quot;NYC&quot;, 5);</span>
<span class="fc" id="L59">        this.addEdge(graph, &quot;NYC&quot;, &quot;LAS&quot;, 3);</span>
<span class="fc" id="L60">        this.addEdge(graph, &quot;BOS&quot;, &quot;LAX&quot;, 4);</span>
<span class="fc" id="L61">        this.addEdge(graph, &quot;LHR&quot;, &quot;BKK&quot;, 9);</span>
<span class="fc" id="L62">        this.addEdge(graph, &quot;BKK&quot;, &quot;SYD&quot;, 11);</span>
<span class="fc" id="L63">        this.addEdge(graph, &quot;LAX&quot;, &quot;LAS&quot;, 2);</span>
<span class="fc" id="L64">        this.addEdge(graph, &quot;DUB&quot;, &quot;ORD&quot;, 6);</span>
<span class="fc" id="L65">        this.addEdge(graph, &quot;LAX&quot;, &quot;SYD&quot;, 13);</span>
<span class="fc" id="L66">        this.addEdge(graph, &quot;LAS&quot;, &quot;SYD&quot;, 14);</span>
<span class="fc" id="L67">    }</span>

    private void addEdge(SimpleWeightedGraph&lt;String, DefaultWeightedEdge&gt; graph, String source, String dest, Integer distance) {
<span class="fc" id="L70">        DefaultWeightedEdge e = new DefaultWeightedEdge();</span>
<span class="fc" id="L71">        graph.addEdge(source, dest, e);</span>
<span class="fc" id="L72">        graph.setEdgeWeight(e, distance);</span>
<span class="fc" id="L73">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.6.202009150832</span></div></body></html>